
var cspc_manager = [];

function update_col_positions() {
	jQuery('.cspc-column').each(function(col) {
		this.cspc_setup();
	});	
}

jQuery(document).ready(function(){
			
	//setup slide down toolbar
	jQuery(document.body).prepend('<div id="cspc-assist-bar"><div id="cspc-assist-bar-content"> </div><div id="cspc-assist-bar-expander">'+cspc_page_columnist_l10n.text.expander+'</div></div>');
	jQuery('#cspc-assist-bar-content').html(''
		+'<div class="cspc-section">'
			+'<input id="cspc-columns-editing" name="cspc-columns-editing" type="checkbox"><label for="cspc-columns-editing">'+cspc_page_columnist_l10n.text.editing+'</label></input>'
			+'<br/>'
			+'<input id="cspc-columns-sizing" name="cspc-columns-sizing" type="checkbox" readonly="readonly"/><label class="cspc-readonly-text" for="cspc-columns-sizing-ro">'+cspc_page_columnist_l10n.text.sizing+'</label>'
			+'<br/>'
			+'<input id="cspc-columns-locking" name="cspc-columns-locking" type="checkbox" readonly="readonly"/><label class="cspc-readonly-text" for="cspc-columns-locking-ro">'+cspc_page_columnist_l10n.text.locking+'</label>'
		+'</div>'
		+'<div class="cspc-section">'
			+'<input id="cspc-col-spacing" type="text" value="'+cspc_page_columnist_l10n.spacing+'" readonly="readonly" style="width:20px;background-color:#fff;color:#000;"/>'
			+'<label>&nbsp;&nbsp;'+cspc_page_columnist_l10n.text.spacing+'</label>'
			+'<br/>'
			+'<input id="cspc-default-spacing" name="cspc-default-spacing" type="checkbox"><label for="cspc-default-spacing">'+cspc_page_columnist_l10n.text.defaultspacing+'</label></input>'
			+'<br/>'
			+'<a id="cspc-save-changes" class="cspc-button" href="javascript:void(0);">'+cspc_page_columnist_l10n.text.save+'</a>'
		+'</div>'
		+'<div class="cspc-section" style="margin-left:8px;margin-top:4px;border-right: 0px none !important;">'
			+'<div class="cspc-widget cscp-widget-calendar" title="'+cspc_page_columnist_l10n.widgets.calendar.text+'" >&nbsp;</div>'
			+'<div class="cspc-widget cscp-widget-stats" title="'+cspc_page_columnist_l10n.widgets.stats.text+'" >&nbsp;</div>'
			+'<label class="cspc-readonly-text" style="font-size: 14px; font-style: bold italic;display:block;width:130px;float:left;padding-top:6px;margin-left:6px;">widget support comming soon, not available!</label>'
		+'</div>'
		+'<div style="clear:left;"> </div>'
	);
	jQuery('#cspc-col-spacing').spin({max:10,min:0,imageBasePath: cspc_page_columnist_l10n.imageBasePath, interval: 0.5 });

	
	//create ghosting columns and spacer
	jQuery('.cspc-column').each(function(col) {
		this.cspc = {
			idx: col,
			ghost: null,
			spacer: null
		}
		this.cspc_box=function() {
			var box = jQuery(this).offset();
			box.width = jQuery(this).width();
			box.height = jQuery(this).height();
			return box;
		}
		this.cspc_setup=function() {
			var box = this.cspc_box();
			if (!this.cspc.ghost) {
				this.cspc.ghost  = document.createElement("DIV");
				this.cspc.spacer = document.createElement("DIV");
				jQuery(this.cspc.ghost).addClass('cspc-assist-col');
				jQuery(this.cspc.spacer).addClass('cspc-assist-spacer');
				if (this.cspc.idx == 0) jQuery(this.cspc.spacer).css({display: 'none'});
				jQuery(document.body).prepend(this.cspc.ghost);
				jQuery(document.body).prepend(this.cspc.spacer);
				jQuery(this.cspc.ghost).hide();
				jQuery(this.cspc.spacer).hide();
			}
			jQuery(this.cspc.ghost).css({ top: box.top+'px',left: box.left+'px',width: box.width+'px', height: box.height+'px' });
			if (this.cspc.idx > 0) {
				var box_prev = cspc_manager[this.cspc.idx-1].cspc_box();
				var lb =  box_prev.left + box_prev.width;
				var lw = (box.left - (box_prev.left + box_prev.width ) );
				try{
					jQuery(this.cspc.spacer).css({ top: box.top+'px',left: lb+'px',width: lw+'px', height: box.height+'px' });
				}catch(e){
					alert("Page Columnist Assistance: IE can't calculate correct, sorry! idx: " +this.cspc.idx+ " box.left: "+box.left+" left: "+lb+" width: "+lw);
				}
			}
		}
		cspc_manager.push(this);
	});
	
	//permit the toolbar slideup/slide down effect
	jQuery('#cspc-assist-bar-expander').click(function(){
		var top_val = (parseInt(jQuery('#cspc-assist-bar').css('top')) == 0 ? '-84px' : '0px');
		jQuery('#cspc-assist-bar').animate({ top: top_val});
	});
	
	jQuery('#cspc-col-spacing').change(function() {
		if (cspc_manager.length == 0) return;
		var space = parseFloat(jQuery(this).val());
		var base = 100.0;
		if (jQuery.browser.msie) base = base - space * 0.15; //because IE is unable to calculate the sums correctly, we have to trick it little bit
//		var perc = Math.floor( ((base - (cspc_manager.length - 1)*space ) / cspc_manager.length) * 100 ) / 100.0;
		var perc = ((base - (cspc_manager.length - 1)*space ) / cspc_manager.length);
		var total = ((cspc_manager.length - 1) * space) + (cspc_manager.length * perc);
		if (jQuery.browser.msie) {
			for (var i=0; i<cspc_manager.length; i++) jQuery(cspc_manager[i]).css({ width: '1px'});
		}
		for (var i=0; i<cspc_manager.length; i++) {
			jQuery(cspc_manager[i]).css({ width: perc+'%'});
			if (i != 0) jQuery(cspc_manager[i]).css({ marginLeft: space+'%'});
		}
		update_col_positions();
		return false;
	});
	
	jQuery('#cspc-columns-editing').click(function() {
		var show = jQuery(this).attr('checked');
		for (i=0; i<cspc_manager.length; i++){
			if (show) {
				jQuery(cspc_manager[i].cspc.ghost).show();
				jQuery(cspc_manager[i].cspc.spacer).show();			
			}else {
				jQuery(cspc_manager[i].cspc.ghost).hide();
				jQuery(cspc_manager[i].cspc.spacer).hide();			
			}
		}
	});
	
	jQuery('#cspc-save-changes').click(function() {
		jQuery(this).blur();
		params = {
			type: 'POST', 
			url: cspc_page_columnist_l10n.adminUrl+'admin-ajax.php',
			data: {
				action: 'cspc_save_changes',
				page_id: cspc_page_columnist_l10n.pageId,
				spacing: jQuery('#cspc-col-spacing').val(),
				default_spacing: jQuery('#cspc-default-spacing').attr('checked')
			},
			success: function(data, textStatus) {
				window.location.reload();
			},
			error: function(xhr, textStatus, error) {
				alert(xhr.responseText);
			}
		};
		jQuery.ajax(params);
	});
	
	//enable window resize tracking to move the boxes correctly
	jQuery(window).resize(update_col_positions);

	//execute first position update delaye because of Safari wrong position calculation in ready state
	setTimeout(update_col_positions, 30); 
});
